#include<bits/stdc++.h>
#define ll long LONG_MAX
#define MAXN 200007
using namespace std;
int a[MAXN];
int b1[MAXN],b2[MAXN];
int main()
{
    ios_base::sync_with_stdio();
    cin.tie(0);cout.tie(0);
    int n;
    cin>>n;
    for(int i=0;i<n;i++)
        cin>>a[i];
    b1[0]=0;
    for(int i=1;i<n;i++)
    {
        if(a[i-1]<=a[i]) b1[i]=b1[i-1];
        else b1[i]=i;
    }
    b2[0]=0;
    b2[1]=0;
    for(int i=2;i<n;i++)
    {
        if(a[i-1]<=a[i]) b2[i]=b2[i-1];
        else
        {
            b2[i]=b1[i-1];
            if(a[i-2]<=a[i]) b2[i]=max(b2[i],b1[i-2]);
        }
    }
    for(int i=0;i<n;i++)
    {
        cout<<b2[i]<<" ";
    }
    cout<<endl;
    int q;
    cin>>q;
    while(q--)
    {
        int l,r;
        cin>>l>>r;
        l--;r--;
        if(l>=b2[r]) cout<<"DA"<<endl;
        else cout<<"NE"<<endl;
    }
}